generateSnakesAndLadders <- function(N = 100, s_and_l)
{
    positions <- 0:(N-1)
    starts <- sample(setdiff(positions, 0L), s_and_l, replace = FALSE)
    ends <- sample(setdiff(positions, starts), s_and_l, replace = TRUE)
    list(starts = starts, ends = ends)
}






throwDice <- function(m, steps)
{
    sample(1:length(m), size = steps, replace = TRUE, prob = m)
}


newPosition <-
    function(cur_position, s_and_l, step, N)
{
    x <- (cur_position + step) %% N

    for (i in 1:length(s_and_l$starts))
    {
        if (x == s_and_l$starts[i])
        {
            x <- s_and_l$ends[i]
            break
        }
    }
    x
}


sim <-
    function(nsides = 10,
             s_and_l = generateSnakesAndLadders(board_size, 6),
             die_probs = runif(nsides),
             board_size = 100, nthrows = 100)
    ## n: sides of dice
    ## s_and_l: number of snakes and ladders
{
    position <- integer(nthrows + 1) # vector of positions
    die_probs <- rep(die_probs, length.out = nsides)
    die_probs <- die_probs / sum(die_probs)
    steps <- throwDice(die_probs, nthrows)
    ## sum(m)
    for (i in 1:nthrows)
    {
        position[i + 1] <- newPosition(position[i],
                                       s_and_l,
                                       step = steps[i],
                                       board_size)
    }
    list(steps = steps, position = position)
}


## replicate(10, sim())

sl <- generateSnakesAndLadders(100, 10)

sl

