theory <- function(nsides = 10,
                   s_and_l = sl,
                   die_probs = 1,
                   board_size = 100)           ##gives the transition matrix(100x100)
{

    die_probs <- rep(die_probs, length.out = nsides)
    die_probs <- die_probs / sum(die_probs)
    m<-die_probs

    mod<-s_and_l$starts+1
    x<-setdiff((1:board_size),mod)
    for (i in 1:board_size)
    {
        a<-integer(board_size)
        if(sum(i==x)>0)
        {
            for (j in 1:nsides)
            {  if (i+j<101)
                   a[i+j]<-m[j]
            else
                a[(i+j)%%(board_size)]<-m[j]
           }
            for (k in 1:length(s_and_l$ends))
            {
                a[s_and_l$ends[k]+1]<-a[s_and_l$ends[k]+1]+a[s_and_l$starts[k]+1]
                a[s_and_l$starts[k]+1]<-0
            }
        }
        
        if(i==1)
            b<-a
        else
            b<-rbind(b,a)
        ##print(sum(a))
        
    }
    as.matrix(b)
}

b <- theory()

library(lattice)
levelplot(b)

old=numeric(100)
old[1]=1
dim(old)=c(1,100)



i <- 1
while (TRUE)             ##searches for static distributions
{
    i <- i + 1
    prev <- old
    old <- old %*% b
    old <- old / sum(old)
    if (all(old == prev))   ##old==prev compares only the first elements
    {
        print(i)
        break
    }
    ##print(sum(old))
}

barplot(old)
